[project @ 1997-11-25 11:50:17 by simonm]
[ghc-hetmet.git] / glafp-utils / runstdtest / runstdtest.prl
1 #
2 # The perl script requires the following variables to be bound
3 # to something meaningful before it will operate correctly:
4 #   
5 #   TMPDIR
6 #   CONTEXT_DIFF
7 #   RM
8 #
9 # Given:
10 #       * a program to run (1st arg)
11 #       * some "command-line opts" ( -O<opt1> -O<opt2> ... )
12 #           [default: anything on the cmd line this script doesn't recognise ]
13 #         the first opt not starting w/ "-" is taken to be an input
14 #         file and (if it exists) is grepped for "what's going on here"
15 #         comments (^--!!!).
16 #       * a file to feed to stdin ( -i<file> ) [default: /dev/null ]
17 #       * a "time" command to use (-t <cmd>).
18 #
19 #       * alternatively, a "-script <script>" argument says: run the
20 #         named Bourne-shell script to do the test.  It's passed the
21 #         pgm-to-run as the one-and-only arg.
22 #
23 # Run the program with those options and that input, and check:
24 # if we get...
25
26 #       * an expected exit status ( -x <val> ) [ default 0 ]
27 #       * expected output on stdout ( -o1 <file> ) [ default /dev/null ]
28 #               ( we'll accept one of several...)
29 #       * expected output on stderr ( -o2 <file> ) [ default /dev/null ]
30 #               ( we'll accept one of several...)
31 #
32 #       (if the expected-output files' names end in .Z, then
33 #        they are uncompressed before doing the comparison)
34
35 # (This is supposed to be a "prettier" replacement for runstdtest.)
36 #
37 #       Flags
38 #       ~~~~~
39 #       -accept-output  replace output files with the ones actually generated by running
40 #                       the program
41 #
42 ($Pgm = $0) =~ s|.*/||;
43 $Verbose = 0;
44 $SaveTmpFile = 0;
45 $Status = 0;
46 @PgmArgs = ();
47 $PgmExitStatus = 0;
48 $PgmStdinFile  = '/dev/null';
49 if ( $ENV{'TMPDIR'} ) { # where to make tmp file names
50     $TmpPrefix = $ENV{'TMPDIR'};
51 } else {
52     $TmpPrefix ="$TMPDIR";
53     $ENV{'TMPDIR'} = "$TMPDIR"; # set the env var as well
54 }
55 $ScriptFile = "$TmpPrefix/run_me$$";
56 $DefaultStdoutFile = "$TmpPrefix/no_stdout$$"; # can't use /dev/null (e.g. Alphas)
57 $DefaultStderrFile = "$TmpPrefix/no_stderr$$";
58 @PgmStdoutFile = ();
59 @PgmStderrFile = ();
60 $PreScript = '';
61 $PostScript = '';
62 $TimeCmd = '';
63 $StatsFile = "$TmpPrefix/stats$$";
64 $SysSpecificTiming = '';
65 $SpixTiming = 'no';
66
67 die "$Pgm: program to run not given as first argument\n" if $#ARGV < 0;
68 $ToRun = $ARGV[0]; shift(@ARGV);
69 # avoid picking up same-named thing from somewhere else on $PATH...
70 $ToRun = "./$ToRun" if $ToRun !~ /^\//;
71
72 arg: while ($_ = $ARGV[0]) {
73     shift(@ARGV);
74     
75     /^--$/      && do { # let anything past after --
76                         push(@PgmArgs, @ARGV);
77                         last arg; };
78
79     /^-v$/             && do { $Verbose = 1; next arg; };
80     /^-accept-output$/ && do { $SaveTmpFile = 1; next arg; };
81
82     /^-O(.*)/   && do { push(@PgmArgs, &grab_arg_arg('-O',$1)); next arg; };
83     /^-i(.*)/   && do { $PgmStdinFile = &grab_arg_arg('-i',$1);
84                         $Status++,
85                         print STDERR "$Pgm: bogus -i input file: $PgmStdinFile\n"
86                             if ! -f $PgmStdinFile;
87                         next arg; };
88     /^-x(.*)/   && do { $PgmExitStatus = &grab_arg_arg('-x',$1);
89                         $Status++ ,
90                         print STDERR "$Pgm: bogus -x expected exit status: $PgmExitStatus\n"
91                             if $PgmExitStatus !~ /^\d+$/;
92                         next arg; };
93     /^-o1(.*)/  && do { $out_file = &grab_arg_arg('-o1',$1);
94                         push(@PgmStdoutFile, $out_file);
95                         next arg; };
96     /^-o2(.*)/  && do { $out_file = &grab_arg_arg('-o2',$1);
97                         push(@PgmStderrFile, $out_file);
98                         next arg; };
99     /^-prescript(.*)/  && do { $PreScript = &grab_arg_arg('-prescript',$1);
100                                 next arg; };
101     /^-postscript(.*)/ && do { $PostScript = &grab_arg_arg('-postscript',$1);
102                                 next arg; };
103     /^-script/ && do { print STDERR "$Pgm: -script argument is obsolete;\nUse -prescript and -postscript instead.\n";
104                     $Status++;
105                     next arg; };
106     /^-(ghc|hbc)-timing$/ && do { $SysSpecificTiming = $1;
107                                   next arg; };
108     /^-spix-timing$/ && do { $SysSpecificTiming = 'ghcspix';
109                              $SpixTiming = 'yes';
110                              next arg; };
111     /^-t(.*)/   && do { $TimeCmd = &grab_arg_arg('-t', $1); next arg; };
112
113     # anything else is taken to be a pgm arg
114     push(@PgmArgs, $_);
115 }
116
117 foreach $out_file ( @PgmStdoutFile ) {
118     if ( ! -f $out_file ) {
119         #$Status++;
120         print STDERR "$Pgm: warning: expected-stdout file missing: $out_file\n";
121         pop(@PgmStdoutFile);
122     }
123 }
124
125 foreach $out_file ( @PgmStderrFile ) {
126     if ( ! -f $out_file ) {
127         #$Status++;
128         pop(@PgmStderrFile);
129         if ( $SaveTmpFile ) {
130             system("touch $out_file");
131         } else {
132             print STDERR "$Pgm: warning: expected-stderr file missing: $out_file\n";
133         }
134     }
135 }
136
137 exit 1 if $Status;
138
139 # add on defaults if none specified
140 @PgmStdoutFile = ( $DefaultStdoutFile ) if $#PgmStdoutFile < 0;
141 @PgmStderrFile = ( $DefaultStderrFile ) if $#PgmStderrFile < 0;
142
143 # tidy up the pgm args:
144 # (1) look for the "first input file"
145 #     and grep it for "interesting" comments (--!!! )
146 # (2) quote any args w/ whitespace in them.
147 $grep_done = 0;
148 foreach $a ( @PgmArgs ) {
149     if (! $grep_done && $a !~ /^-/ && -f $a) {
150         print `egrep "^--!!!" $a`;
151         $grep_done = 1;
152     }
153     if ($a =~ /\s/ || $a =~ /'/) {
154         $a =~ s/'/\\'/g;    # backslash the quotes;
155         $a = "\"$a\"";      # quote the arg
156     }
157 }
158
159 # deal with system-specific timing options
160 $TimingMagic = '';
161 if ( $SysSpecificTiming =~ /^ghc/ ) {
162     $TimingMagic = "+RTS -s$StatsFile -RTS"
163 } elsif ( $SysSpecificTiming eq 'hbc' ) {
164     $TimingMagic = "-S$StatsFile";
165 }
166
167 $ToRunOrig = $ToRun;
168 if ( $SpixTiming eq 'yes' ) {
169     $ToRun .= '.spix';
170
171     # gotta find first/last addresses in the mutator code
172     $FirstSpix = '_callWrapper';
173     $LastSpix  = '???'; # usually _mpz_get_si, but can't be sure
174
175     open(SPIXNM, "nm -n $ToRunOrig |") || die "nm -n $ToRunOrig open failed!\n";
176     spix: while (<SPIXNM>) {
177         if ( / T +(_freeForeignObj|_([A-Za-z]+)Hook|_xmalloc|_mpz_get_si)$/ ) {
178             $LastSpix = $1;
179             last spix;
180         }
181     }
182     close(SPIXNM); # || die "nm -n $ToRunOrig close failed!\n";
183
184     $SpixifyLine1 = "spix -o $ToRun -t$FirstSpix,$LastSpix $ToRunOrig";
185     $SpixstatsLine1 = "spixstats -b $TmpPrefix/runtest$$.3 $ToRunOrig > $ToRunOrig.spixstats1";
186     $SpixifyLine2 = "spix -o $ToRun +t$FirstSpix,$LastSpix $ToRunOrig";
187     $SpixstatsLine2 = "spixstats -b $TmpPrefix/runtest$$.3 $ToRunOrig > $ToRunOrig.spixstats2";
188 } else {
189     $SpixifyLine1 = '';
190     $SpixstatsLine1 = '';
191     $SpixifyLine2 = '';
192     $SpixstatsLine2 = '';
193 }
194
195 if ($PreScript ne '') {
196     local($to_do);
197     $PreScriptLines = `cat $PreScript`;
198 } else {
199     $PreScriptLines = '';
200 }
201
202 if ($PostScript ne '') {
203     local($to_do);
204     $PostScriptLines = `cat $PostScript`;
205     $* = 1;
206     $PostScriptLines =~ s#\$o1#$TmpPrefix/runtest$$.1#g;
207     $PostScriptLines =~ s#\$o2#$TmpPrefix/runtest$$.2#g;
208 } else {
209     $PostScriptLines = '';
210 }
211
212 # OK, so we're gonna do the normal thing...
213
214 $Script = <<EOSCRIPT;
215 #! /bin/sh
216 myexit=0
217 diffsShown=0
218 rm -f $DefaultStdoutFile $DefaultStderrFile
219 cat /dev/null > $DefaultStdoutFile
220 cat /dev/null > $DefaultStderrFile
221 $PreScriptLines
222 $SpixifyLine1
223 $TimeCmd /bin/sh -c \'$ToRun $TimingMagic @PgmArgs < $PgmStdinFile 1> $TmpPrefix/runtest$$.1 2> $TmpPrefix/runtest$$.2 3> $TmpPrefix/runtest$$.3\'
224 progexit=\$?
225 if [ \$progexit -ne $PgmExitStatus ]; then
226     echo $ToRun @PgmArgs \\< $PgmStdinFile
227     echo "****" expected exit status $PgmExitStatus not seen \\; got \$progexit
228     myexit=1
229 else
230     $PostScriptLines
231     hit='NO'
232     for out_file in @PgmStdoutFile ; do
233         if cmp -s \$out_file $TmpPrefix/runtest$$.1 ; then
234             hit='YES'
235         fi
236     done
237     if [ \$hit = 'NO' ] ; then
238         echo $ToRun @PgmArgs \\< $PgmStdinFile
239         echo expected stdout not matched by reality
240         ${CONTEXT_DIFF} $PgmStdoutFile[0] $TmpPrefix/runtest$$.1
241         myexit=1
242         diffsShown=1
243     fi
244     if [ $SaveTmpFile = 1 ] && [ \$progexit = $PgmExitStatus ] ; then
245         rm -f $PgmStdoutFile[0].bak
246         echo Saving away stdout output in $PgmStdoutFile[0] ...
247         cp $PgmStdoutFile[0] $PgmStdoutFile[0].bak
248         cp $TmpPrefix/runtest$$.1 $PgmStdoutFile[0]
249     fi
250 fi
251 egrep -v '^ld\.so:.*has older revision than expected' < $TmpPrefix/runtest$$.2 > $TmpPrefix/runtest$$.2b
252 mv -f $TmpPrefix/runtest$$.2b $TmpPrefix/runtest$$.2
253
254 hit='NO'
255 for out_file in @PgmStderrFile ; do
256     if cmp -s \$out_file $TmpPrefix/runtest$$.2 ; then
257         hit='YES'
258     fi
259 done
260 if [ \$hit = 'NO' ] ; then
261     echo $ToRun @PgmArgs \\< $PgmStdinFile
262     echo expected stderr not matched by reality
263     ${CONTEXT_DIFF} $PgmStderrFile[0] $TmpPrefix/runtest$$.2
264     myexit=1
265     diffsShown=1
266 fi
267 if [ $SaveTmpFile = 1 ] && [ \$progexit = $PgmExitStatus ] ; then
268         rm -f $PgmStderrFile[0].bak
269         echo Saving away stderr output in $PgmStderrFile[0] ...
270         cp $PgmStderrFile[0] $PgmStderrFile[0].bak
271         cp $TmpPrefix/runtest$$.2 $PgmStderrFile[0]
272 fi
273 $SpixstatsLine1
274
275 if [ $SpixTiming = 'yes' -a \$myexit = 0 ] ; then
276     $SpixifyLine2
277     $TimeCmd /bin/sh -c \'$ToRun $TimingMagic @PgmArgs < $PgmStdinFile 1> /dev/null 2> /dev/null 3> $TmpPrefix/runtest$$.3\'
278     $SpixstatsLine2
279 fi
280
281 ${RM} core $ToRunOrig.spix $DefaultStdoutFile $DefaultStderrFile $TmpPrefix/runtest$$.1 $TmpPrefix/runtest$$.2 $TmpPrefix/runtest$$.3
282 exit \$myexit
283 EOSCRIPT
284
285 # bung script into a file
286 open(SCR, "> $ScriptFile") || die "Failed opening script file $ScriptFile!\n";
287 print SCR $Script;
288 close(SCR) || die "Failed closing script file!\n";
289 chmod 0755, $ScriptFile;
290
291 print STDERR $Script if $Verbose;
292
293 &run_something($ScriptFile);
294
295 if ( $SysSpecificTiming eq '' ) {
296     unlink $StatsFile;
297     unlink $ScriptFile;
298     exit 0;
299 }
300
301 &process_stats_file();
302 &process_spixstats_files() if $SpixTiming eq 'yes';
303
304 # print out what we found
305 if ( $SpixTiming ne 'yes' ) {
306     print STDERR "<<$SysSpecificTiming: ",
307         "$BytesAlloc bytes, $GCs GCs, $AvgResidency/$MaxResidency avg/max bytes residency ($ResidencySamples samples), $InitTime INIT ($InitElapsed elapsed), $MutTime MUT ($MutElapsed elapsed), $GcTime GC ($GcElapsed elapsed)",
308         " :$SysSpecificTiming>>\n";
309 } else {
310     print STDERR "<<$SysSpecificTiming: ",
311         "$BytesAlloc bytes, $GCs GCs, $AvgResidency/$MaxResidency avg/max bytes residency ($ResidencySamples samples), $TotalInsns[1]/$TotalInsns[2] instructions, $LoadInsns[1]/$LoadInsns[2] loads, $StoreInsns[1]/$StoreInsns[2] stores, $BranchInsns[1]/$BranchInsns[2] branches, $OtherInsns[1]/$OtherInsns[2] others",
312         " :$SysSpecificTiming>>\n";
313 }
314
315 # OK, party over
316 unlink $StatsFile;
317 unlink $ScriptFile;
318 exit 0;
319
320 sub grab_arg_arg {
321     local($option, $rest_of_arg) = @_;
322     
323     if ($rest_of_arg) {
324         return($rest_of_arg);
325     } elsif ($#ARGV >= 0) {
326         local($temp) = $ARGV[0]; shift(@ARGV); 
327         return($temp);
328     } else {
329         print STDERR "$Pgm: no argument following $option option\n";
330         $Status++;
331     }
332 }
333
334 sub run_something {
335     local($str_to_do) = @_;
336
337 #   print STDERR "$str_to_do\n" if $Verbose;
338
339     local($return_val) = 0;
340     system($str_to_do);
341     $return_val = $?;
342
343     if ($return_val != 0) {
344 #ToDo: this return-value mangling is wrong
345 #       local($die_msg) = "$Pgm: execution of the $tidy_name had trouble";
346 #       $die_msg .= " (program not found)" if $return_val == 255;
347 #       $die_msg .= " ($!)" if $Verbose && $! != 0;
348 #       $die_msg .= "\n";
349         unlink $ScriptFile;
350         unlink $StatsFile;
351
352         exit (($return_val == 0) ? 0 : 1);
353     }
354 }
355
356 sub process_stats_file {
357
358     # OK, process system-specific stats file
359     if ( $SysSpecificTiming =~ /^ghc/ ) {
360
361         #NB: nearly the same as in GHC driver's -ghc-timing stuff
362
363         open(STATS, $StatsFile) || die "Failed when opening $StatsFile\n";
364
365         local($max_live)    = 0; 
366         local($tot_live)    = 0; # for calculating residency stuff
367         local($tot_samples) = 0;
368
369         while (<STATS>) {
370             if (! /Minor/ && /^\s*\d+\s+\d+\s+(\d+)\s+\d+\.\d+\%/ ) {
371                 $max_live = $1 if $max_live < $1;
372                 $tot_live += $1;
373                 $tot_samples += 1;
374             }
375
376             $BytesAlloc = $1 if /^\s*([0-9,]+) bytes allocated in the heap/;
377
378 #           if ( /^\s*([0-9,]+) bytes maximum residency .* (\d+) sample/ ) {
379 #               $MaxResidency = $1; $ResidencySamples = $2;
380 #           }
381
382             $GCs = $1 if /^\s*([0-9,]+) garbage collections? performed/;
383
384             if ( /^\s*INIT\s+time\s*(\d+\.\d\d)s\s*\(\s*(\d+\.\d\d)s elapsed\)/ ) {
385                 $InitTime = $1; $InitElapsed = $2;
386             } elsif ( /^\s*MUT\s+time\s*(\d+\.\d\d)s\s*\(\s*(\d+\.\d\d)s elapsed\)/ ) {
387                 $MutTime = $1; $MutElapsed = $2;
388             } elsif ( /^\s*GC\s+time\s*(\d+\.\d\d)s\s*\(\s*(\d+\.\d\d)s elapsed\)/ ) {
389                 $GcTime = $1; $GcElapsed = $2;
390             }
391         }
392         close(STATS) || die "Failed when closing $StatsFile\n";
393         if ( $tot_samples > 0 ) {
394             $ResidencySamples = $tot_samples;
395             $MaxResidency = $max_live;
396             $AvgResidency = int ($tot_live / $tot_samples) ;
397         }
398
399     } elsif ( $SysSpecificTiming eq 'hbc' ) {
400
401         open(STATS, $StatsFile) || die "Failed when opening $StatsFile\n";
402         while (<STATS>) {
403             $BytesAlloc = $1 if /^\s*([0-9]+) bytes allocated from the heap/;
404
405             $GCs = $1 if /^\s*([0-9]+) GCs?,$/;
406
407             if ( /^\s*(\d+\.\d\d) \((\d+\.\d)\) seconds total time,$/ ) {
408                 $MutTime = $1; $MutElapsed = $2; # will fix up later
409
410                 $InitTime = 0; $InitElapsed = 0; # hbc doesn't report these
411
412             } elsif ( /^\s*(\d+\.\d\d) \((\d+\.\d)\) seconds GC time/ ) {
413                 $GcTime = $1; $GcElapsed = $2;
414
415                 # fix up mutator time now
416                 $MutTime    = sprintf("%.2f", ($MutTime    - $GcTime));
417                 $MutElapsed = sprintf("%.1f", ($MutElapsed - $GcElapsed));
418             }
419         }
420         close(STATS) || die "Failed when closing $StatsFile\n";
421     }
422
423     # warn about what we didn't find
424     print STDERR "Warning: BytesAlloc not found in stats file\n" unless defined($BytesAlloc);
425     print STDERR "Warning: GCs not found in stats file\n" unless defined($GCs);
426     print STDERR "Warning: InitTime not found in stats file\n" unless defined($InitTime);
427     print STDERR "Warning: InitElapsed not found in stats file\n" unless defined($InitElapsed);
428     print STDERR "Warning: MutTime not found in stats file\n" unless defined($MutTime);
429     print STDERR "Warning: MutElapsed not found in stats file\n" unless defined($MutElapsed);
430     print STDERR "Warning: GcTime inot found in stats file\n" unless defined($GcTime);
431     print STDERR "Warning: GcElapsed not found in stats file\n" unless defined($GcElapsed);
432
433     # things we didn't necessarily expect to find
434     $MaxResidency     = 0 unless defined($MaxResidency);
435     $AvgResidency     = 0 unless defined($AvgResidency);
436     $ResidencySamples = 0 unless defined($ResidencySamples);
437
438     # a bit of tidying
439     $BytesAlloc =~ s/,//g;
440     $MaxResidency =~ s/,//g;
441     $GCs =~ s/,//g;
442     $InitTime =~ s/,//g;
443     $InitElapsed =~ s/,//g;
444     $MutTime =~ s/,//g;
445     $MutElapsed =~ s/,//g;
446     $GcTime =~ s/,//g;
447     $GcElapsed =~ s/,//g;
448 }
449
450 sub process_spixstats_files { # 2 of them; one for mutator, one for GC
451
452     @TotalInsns = ();
453     @LoadInsns  = ();
454     @StoreInsns = ();
455     @BranchInsns= ();
456     @OtherInsns = ();
457
458     foreach $f (1, 2) {
459
460       open(STATS, "< $ToRunOrig.spixstats$f") || die "Failed when opening $ToRunOrig.spixstats$f\n";
461       while (<STATS>) {
462           last if /^OPCODES \(STATIC\):/; # party over
463
464           next if /^OPCODES \(DYNAMIC\):/;
465           next if /^$/;
466           next if /^opcode\s+#executed/;
467           next if /^SUBTOTAL/;
468
469           if ( /^ld\S*\s+(\d+)/ ) {
470               $LoadInsns[$f] += $1;
471
472           } elsif ( /^st\S*\s+(\d+)/ ) {
473               $StoreInsns[$f] += $1;
474
475           } elsif ( /^(jmpl|call|b\S*)\s+(\d+)/ ) {
476               $BranchInsns[$f] += $2;
477
478           } elsif ( /^TOTAL\s+(\d+)/ ) {
479               $TotalInsns[$f] = $1;
480               print STDERR "TotalInsns doesn't match categories total!\n"
481                   if $TotalInsns[$f] !=
482                      ($LoadInsns[$f] + $StoreInsns[$f] + $BranchInsns[$f] + $OtherInsns[$f]);
483
484           } elsif ( /^\S+\s+(\d+)/ ) {
485               $OtherInsns[$f] += $1;
486
487           } else {
488               die "Funny line?? $_";
489           }
490       }
491       close(STATS) || die "Failed when closing $ToRunOrig.spixstats\n";
492     }
493 }